// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlSignalGroup")]
    pub struct SignalGroup(Object<ffi::DzlSignalGroup, ffi::DzlSignalGroupClass>);

    match fn {
        type_ => || ffi::dzl_signal_group_get_type(),
    }
}

impl SignalGroup {
    #[doc(alias = "dzl_signal_group_new")]
    pub fn new(target_type: glib::types::Type) -> SignalGroup {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::dzl_signal_group_new(target_type.into_glib())) }
    }

    #[doc(alias = "dzl_signal_group_block")]
    pub fn block(&self) {
        unsafe {
            ffi::dzl_signal_group_block(self.to_glib_none().0);
        }
    }

    //#[doc(alias = "dzl_signal_group_connect")]
    //pub fn connect<P: Fn() + 'static>(&self, detailed_signal: &str, c_handler: P, data: /*Unimplemented*/Option<Basic: Pointer>) {
    //    unsafe { TODO: call ffi:dzl_signal_group_connect() }
    //}

    //#[doc(alias = "dzl_signal_group_connect_after")]
    //pub fn connect_after<P: Fn() + 'static>(&self, detailed_signal: &str, c_handler: P, data: /*Unimplemented*/Option<Basic: Pointer>) {
    //    unsafe { TODO: call ffi:dzl_signal_group_connect_after() }
    //}

    //#[doc(alias = "dzl_signal_group_connect_data")]
    //pub fn connect_data<P: Fn() + 'static>(&self, detailed_signal: &str, c_handler: P, data: /*Unimplemented*/Option<Basic: Pointer>, notify: /*Unimplemented*/Fn(/*Unimplemented*/Option<Basic: Pointer>), flags: glib::ConnectFlags) {
    //    unsafe { TODO: call ffi:dzl_signal_group_connect_data() }
    //}

    //#[doc(alias = "dzl_signal_group_connect_object")]
    //pub fn connect_object<P: Fn() + 'static>(&self, detailed_signal: &str, c_handler: P, object: /*Unimplemented*/Option<Basic: Pointer>, flags: glib::ConnectFlags) {
    //    unsafe { TODO: call ffi:dzl_signal_group_connect_object() }
    //}

    //#[doc(alias = "dzl_signal_group_connect_swapped")]
    //pub fn connect_swapped<P: FnOnce() + 'static>(&self, detailed_signal: &str, c_handler: P, data: /*Unimplemented*/Option<Basic: Pointer>) {
    //    unsafe { TODO: call ffi:dzl_signal_group_connect_swapped() }
    //}

    #[doc(alias = "dzl_signal_group_get_target")]
    #[doc(alias = "get_target")]
    pub fn target(&self) -> Option<glib::Object> {
        unsafe { from_glib_none(ffi::dzl_signal_group_get_target(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_signal_group_set_target")]
    pub fn set_target(&self, target: Option<&impl IsA<glib::Object>>) {
        unsafe {
            ffi::dzl_signal_group_set_target(
                self.to_glib_none().0,
                target.map(|p| p.as_ref()).to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_signal_group_unblock")]
    pub fn unblock(&self) {
        unsafe {
            ffi::dzl_signal_group_unblock(self.to_glib_none().0);
        }
    }

    #[doc(alias = "target-type")]
    pub fn target_type(&self) -> glib::types::Type {
        ObjectExt::property(self, "target-type")
    }

    #[doc(alias = "bind")]
    pub fn connect_bind<F: Fn(&Self, &glib::Object) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn bind_trampoline<F: Fn(&SignalGroup, &glib::Object) + 'static>(
            this: *mut ffi::DzlSignalGroup,
            instance: *mut glib::gobject_ffi::GObject,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this), &from_glib_borrow(instance))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"bind\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    bind_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "unbind")]
    pub fn connect_unbind<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn unbind_trampoline<F: Fn(&SignalGroup) + 'static>(
            this: *mut ffi::DzlSignalGroup,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"unbind\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    unbind_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "target")]
    pub fn connect_target_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_target_trampoline<F: Fn(&SignalGroup) + 'static>(
            this: *mut ffi::DzlSignalGroup,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::target\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_target_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for SignalGroup {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("SignalGroup")
    }
}
